
#include "MotionDetector.h"


void MotionDetector::ComputeNormalFlow(double gradAdd, double normThresh, ImgFloat& gradx, ImgFloat& grady, ImgFloat& gradT, ImgGray *mask)
{
	double m_gradAdd = gradAdd;
	double m_normThresh = normThresh;

	double m_lut[256][256];
	int x,y;
	int height = gradx.Height();
	int width = gradx.Width();

	mask->Reset(gradx.Width(), grady.Height());
	
	char c,d;
	unsigned char *p=(unsigned char*)(&c);
	unsigned char *q=(unsigned char*)(&d);
	
	for(y=-128;y<=127;y++) {
		for(x=-128;x<=127;x++) {
			c=y; d=x;
			m_lut[*p][*q]=
				-m_normThresh*sqrt((double)c*c + (double)d*d)
				-m_normThresh*m_gradAdd;
		}
	}

	for(y=0; y<height; y++) {
		for(x=0; x<width; x++) {
			int it;

			if(gradT(x,y) < 0)
				it = -gradT(x,y);
			else
				it = gradT(x,y);

			(*mask)(x,y) = (it + m_lut[(unsigned char)gradx(x,y)][(unsigned char)grady(x,y)] > 0 ) ? 255 : 0;
		}
	}
}

void MotionDetector::SubtractAfterWarping(ImgBgr& imgFrame, ImgBgr& prev_imgFrame, KltFeatureList& fl, KltTrackingContext& tc, ImgGray *const warpImage, ImgGray *const subtractedImage)
{
// commented 11/16/09; Prakash says this isn't be used anymore -- STB
//
//	int i;
//	// Scratch images used by the algo..
//	
//	ImgGray curr_image, prev_image;
//	ImgBgr prev_dispFrame, curr_dispFrame;
//
//	Convert(imgFrame, &curr_image);
//	Convert(prev_imgFrame, &prev_image);
//
//	int num_features = fl.GetNFeatures();
//	double* Points1 = new double [2*num_features];
//	double* Points2 = new double [2*num_features];
//
//	tc.SelectGoodFeatures(&fl, prev_image);
//	prev_dispFrame = prev_imgFrame;
//	tc.OverlayFeatures(&prev_dispFrame, fl);
//
//	for(i=0; i<num_features; i++) {
//		Points1[2*i] = fl[i]->x;
//		Points1[2*i+1] = fl[i]->y;
//	}
//
//	tc.TrackFeatures(&fl, prev_image, curr_image);
//	tc.ReplaceLostFeatures(&fl, curr_image);
//	curr_dispFrame = imgFrame;
//	tc.OverlayFeatures(&curr_dispFrame, fl);
//
//	for(i=0; i<num_features; i++) {
//		Points2[2*i] = fl[i]->x;
//		Points2[2*i+1] = fl[i]->y;
//	}
//
//	// Ransac
//	
//	double H[9];
//	int* inliers = new int [num_features];
//	int numInliers = ransacfithomography(ProjectiveTransformation::Homography, DegeneracyCheck::Level2, 4,
//				   Points1, Points2, 2, num_features, 0.02, H, inliers);
//	printf("Num Inliers: %d\n", numInliers);
//	printf("%lf %lf %lf\n", H[0], H[1], H[2]);
//	printf("%lf %lf %lf\n", H[3], H[4], H[5]);
//	printf("%lf %lf %lf\n-----------------\n", H[6], H[7], H[8]);
//	MatDbl H_mat(3,3);
//	H_mat(0,0) = H[0];
//	H_mat(0,1) = H[1];
//	H_mat(0,2) = H[2];
//	H_mat(1,0) = H[3];
//	H_mat(1,1) = H[4];
//	H_mat(1,2) = H[5];
//	H_mat(2,0) = H[6];
//	H_mat(2,1) = H[7];
//	H_mat(2,2) = H[8];
//
//	//ImgGray motion_image,warp_image;
//	WarpHomography(curr_image, H_mat, warpImage);
//	Subtract(prev_image, *warpImage, subtractedImage);
//
//	delete [] Points1;
//	delete [] Points2;
//	delete [] inliers;
//
}


void MotionDetector::WarpImage(const ImgGray& curr_image, const ImgGray& prev_image, KltFeatureList& fl, KltTrackingContext& tc, ImgGray *warpImage)
{
// commented 11/16/09; Prakash says this isn't be used anymore -- STB
//
//	int i;
//	// Scratch images used by the algo..
//	
//	ImgBgr prev_dispFrame, curr_dispFrame;
//
//	int num_features = fl.GetNFeatures();
//	double* Points1 = new double [2*num_features];
//	double* Points2 = new double [2*num_features];
//
//	tc.SelectGoodFeatures(&fl, prev_image);
//
//	/*
//	Convert(prev_image, &prev_dispFrame);
//	tc.OverlayFeatures(&prev_dispFrame, fl);
//	static Figure temp_wnd;
//	temp_wnd.Draw(prev_dispFrame);
//	*/
//
//	for(i=0; i<num_features; i++) {
//		Points1[2*i] = fl[i]->x;
//		Points1[2*i+1] = fl[i]->y;
//	}
//
//	tc.TrackFeatures(&fl, prev_image, curr_image);
//	tc.ReplaceLostFeatures(&fl, curr_image);
//
//	/*
//	Convert(curr_image, &curr_dispFrame);
//	tc.OverlayFeatures(&curr_dispFrame, fl);
//	static Figure temp_wnd2;
//	temp_wnd2.Draw(curr_dispFrame);
//	*/
//
//	for(i=0; i<num_features; i++) {
//		Points2[2*i] = fl[i]->x;
//		Points2[2*i+1] = fl[i]->y;
//	}
//
//	// Ransac
//	
//	double H[9];
//	int* inliers = new int [num_features];
//	int numInliers = ransacfithomography(ProjectiveTransformation::Homography, DegeneracyCheck::Level2, 4,
//				   Points1, Points2, 2, num_features, 0.02, H, inliers);
//	printf("Num Inliers: %d\n", numInliers);
//	printf("%lf %lf %lf\n", H[0], H[1], H[2]);
//	printf("%lf %lf %lf\n", H[3], H[4], H[5]);
//	printf("%lf %lf %lf\n-----------------\n", H[6], H[7], H[8]);
//	MatDbl H_mat(3,3);
//	H_mat(0,0) = H[0];
//	H_mat(0,1) = H[1];
//	H_mat(0,2) = H[2];
//	H_mat(1,0) = H[3];
//	H_mat(1,1) = H[4];
//	H_mat(1,2) = H[5];
//	H_mat(2,0) = H[6];
//	H_mat(2,1) = H[7];
//	H_mat(2,2) = H[8];
//
//	//ImgGray motion_image,warp_image;
//	WarpHomography(curr_image, H_mat, warpImage);
//
//	delete [] Points1;
//	delete [] Points2;
//	delete [] inliers;
//
}

void MotionDetector::ComputeKltMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask, Rect& context, float& du, float& dv, ImgBgr& display_image, int rgn_id)
{
	int width = prev_frame.Width();
	int height = prev_frame.Height();
	ImgBgr sm_prev_frame, sm_curr_frame;
	ImgGray g_sm_prev_frame, g_sm_curr_frame;
	ImgBinary sm_obj_mask;
    KltTrackingContext tc;
	int nfeatures, i;

	// compute the context width and height and reset the small image sizes
	int sm_width = context.right - context.left;
	int sm_height = context.bottom - context.top;
	sm_prev_frame.Reset(sm_width, sm_height);
	sm_curr_frame.Reset(sm_width, sm_height);
	sm_obj_mask.Reset(sm_width, sm_height);
	int num_features = (sm_width * sm_height)/20;
	KltFeatureList fl(num_features), old_fl;

	// Crop the previous frame and detect the features
	Set(&sm_prev_frame, Point(0,0), prev_frame, context);
	Convert(sm_prev_frame, &g_sm_prev_frame);
	tc.SelectGoodFeatures(&fl, g_sm_prev_frame);

	// Crop the mask and remove all feature points not in the mask area
	Set(&sm_obj_mask, Point(0,0), object_mask, context);
	nfeatures = fl.GetNFeatures();
	for(i=0; i<nfeatures; i++) {
		if(fl[i]->x < 0 || fl[i]->x >= width || fl[i]->y < 0 || fl[i]->y >= height) {
			fl[i]->val = -1;
			fl[i]->x = 0;
			fl[i]->y = 0;
			continue;
		}
		if(!sm_obj_mask(fl[i]->x, fl[i]->y)) {
			fl[i]->val = -1;
		}
	}
	old_fl = fl;

	// Crop the current frame
	Set(&sm_curr_frame, Point(0,0), curr_frame, context);
	Convert(sm_curr_frame, &g_sm_curr_frame);

	static Figure sm_prev_wnd("Prev");
	sm_prev_wnd.Draw(sm_prev_frame);
	static Figure sm_curr_wnd("Curr");
	sm_curr_wnd.Draw(sm_curr_frame);
	static Figure sm_mask("Mask");
	sm_mask.Draw(sm_obj_mask);
	
	// track the features
    tc.TrackFeatures(&fl, g_sm_prev_frame, g_sm_curr_frame);
    //tc.ReplaceLostFeatures(&fl, g_sm_curr_frame);

	// Display the motion vec..
	du = 0.0f; dv = 0.0f;
	nfeatures = fl.GetNFeatures();
	for(i=0; i<nfeatures; i++) {
		if(fl[i]->val < 0)
			continue;
		int prev_x = old_fl[i]->x + context.left;
		int prev_y = old_fl[i]->y + context.top;
		int curr_x = fl[i]->x + context.left;
		int curr_y = fl[i]->y + context.top;
		curr_x += (curr_x - prev_x);
		curr_y += (curr_y - prev_y);
		//DrawDot(Point(prev_x, prev_y), &display_image, Bgr(0,255,0), 3);
		if(rgn_id == 0)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,255,0), 1);
		else if(rgn_id == 1)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,0,0), 1);
		else if(rgn_id == 2)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,255,255), 1);
		else if(rgn_id == 3)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,255,0), 1);
		else if(rgn_id == 4)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,0,255), 1);
		else if(rgn_id == 5)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,0,255), 1);
		du += (fl[i]->x - old_fl[i]->x);
		dv += (fl[i]->y - old_fl[i]->y);
	}
	du /= num_features;
	dv /= num_features;

}

void MotionDetector::ComputeJointKltMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask, Rect& context, float& du, float& dv, ImgBgr& display_image, int pyrlevel, int mindist, int rgn_id)
{
	ImgBgr sm_prev_frame, sm_curr_frame;
	ImgGray g_sm_prev_frame, g_sm_curr_frame;
	ImgBinary sm_obj_mask;
	jGaussDerivPyramid prev_pyr, curr_pyr;
	vector<jFeature> jklt_features;
	ImgBgr bgr;

	// compute the context width and height and reset the small image sizes
	int sm_width = context.right - context.left;
	int sm_height = context.bottom - context.top;
	sm_prev_frame.Reset(sm_width, sm_height);
	sm_curr_frame.Reset(sm_width, sm_height);
	sm_obj_mask.Reset(sm_width, sm_height);
	int num_features = (sm_width * sm_height)/20;

	// Crop the previous frame and compute the pyr
	Set(&sm_prev_frame, Point(0,0), prev_frame, context);
	Convert(sm_prev_frame, &g_sm_prev_frame);
	jComputeGaussDerivPyramid(g_sm_prev_frame, &prev_pyr, pyrlevel);

	// Detect feature
	jDetectFeatures(prev_pyr, num_features, &jklt_features);

	// Crop the mask and remove all feature points not in the mask area
	Set(&sm_obj_mask, Point(0,0), object_mask, context);
	for(vector<jFeature>::iterator feat_vec = jklt_features.begin(); feat_vec != jklt_features.end(); feat_vec++) {
		jFeature jf = *feat_vec;
		if(jf.x < 0 || jf.y < 0 || jf.x >= sm_width || jf.y >= sm_height || !sm_obj_mask(jf.x, jf.y)) {
			feat_vec = jklt_features.erase(feat_vec);
			feat_vec--;
		}
	}

	// Crop the current frame and compute the pyr
	Set(&sm_curr_frame, Point(0,0), curr_frame, context);
	Convert(sm_curr_frame, &g_sm_curr_frame);
	jComputeGaussDerivPyramid(g_sm_curr_frame, &curr_pyr, pyrlevel);

	// Track the features
    jTrackFeaturesJointly(&jklt_features, prev_pyr, curr_pyr);
    jReplaceFeatures(&jklt_features, curr_pyr, mindist);

	// Display the motion vec..
	du = 0.0f; dv = 0.0f;
	for(int j=0; j<jklt_features.size(); j++) {
		double dispx = jklt_features[j].dx * 1.0f;
		double dispy = jklt_features[j].dy * 1.0f;
		int prev_x = blepo_ex::Round(jklt_features[j].x-dispx) + context.left;
		int prev_y = blepo_ex::Round(jklt_features[j].y-dispy) + context.top;
		int curr_x = blepo_ex::Round(jklt_features[j].x) + context.left;
		int curr_y = blepo_ex::Round(jklt_features[j].y) + context.top;
		//DrawDot(Point(curr_x, curr_y), &display_image, Bgr(0,255,0), 3);
		//DrawDot(Point(prev_x, prev_y), &display_image, Bgr(0,255,0), 2);

		if(rgn_id == 0)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,255,0), 1);
		else if(rgn_id == 1)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,0,0), 1);
		else if(rgn_id == 2)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,255,255), 1);
		else if(rgn_id == 3)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,255,0), 1);
		else if(rgn_id == 4)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(0,0,255), 1);
		else if(rgn_id == 5)
			DrawLine(Point(prev_x, prev_y), Point(curr_x, curr_y), &display_image, Bgr(255,0,255), 1);

		du += jklt_features[j].dx;
		dv += jklt_features[j].dy;
	}
	du /= jklt_features.size();
	dv /= jklt_features.size();
}

void MotionDetector::HornSchunk(ImgGray& img1, ImgGray& img2, ImgFloat *vel_x, ImgFloat *vel_y)
{
  const int nlevels = 2;
  const float lambda = 100.0f;//1000.0f; //0.1f; //1000000.0f;

  jGaussDerivPyramid pyr1, pyr2;
  jComputeGaussDerivPyramid(img1, &pyr1, nlevels);
  jComputeGaussDerivPyramid(img2, &pyr2, nlevels);

  HornSchunck(pyr1, pyr2, vel_x, vel_y, lambda);

  static Figure x_wnd("u comp");
  static Figure y_wnd("v comp");

  x_wnd.Draw(*vel_x);
  y_wnd.Draw(*vel_y);

}

void MotionDetector::BlockMatch(ImgGray &img1, ImgGray &img2, ImgFloat *vel_x, ImgFloat *vel_y)
{
	CSize block_size(8, 8);
	CSize shift_size(1, 1);
	CSize max_range(10, 10);
	bool use_previous = false;

	int width = img1.Width();
	int height = img1.Height();

	ImgFloat temp_x, temp_y;

	OpticalFlowBlockMatchOpencv(img1, img2, block_size, shift_size, max_range, use_previous, &temp_x, &temp_y);

	vel_x->Reset( width, height );
	vel_y->Reset( width, height );
	for (int y=0 ; y<height ; y++)
	{
	  for (int x=0 ; x<width ; x++)
	  {
		(*vel_x)(x,y) = temp_x(x / block_size.cx, y / block_size.cy);
		(*vel_y)(x,y) = temp_y(x / block_size.cx, y / block_size.cy);
	  }
	}

}

/*
void MotionDetector::ComputeRegionMotion(const ImgBgr& prev_frame, const ImgBgr& curr_frame, const ImgBinary& object_mask1, const ImgBinary& object_mask2, Rect& context, float& du, float& dv, ImgBgr& display_image)
{
	int width = prev_frame.Width();
	int height = prev_frame.Height();
	ImgBgr sm_prev_frame, sm_curr_frame;
	ImgGray g_sm_prev_frame, g_sm_curr_frame;
	ImgBinary sm_obj_mask1, sm_obj_mask2;
    KltTrackingContext tc;
	int nfeatures, i;

	// compute the context width and height and reset the small image sizes
	int sm_width = context.right - context.left;
	int sm_height = context.bottom - context.top;
	sm_prev_frame.Reset(sm_width, sm_height);
	sm_curr_frame.Reset(sm_width, sm_height);
	sm_obj_mask1.Reset(sm_width, sm_height);
	sm_obj_mask2.Reset(sm_width, sm_height);
	int num_features = (sm_width * sm_height)/30;
	KltFeatureList fl(num_features), old_fl;

	// Crop the previous frame and detect the features
	Set(&sm_prev_frame, Point(0,0), prev_frame, context);
	Convert(sm_prev_frame, &g_sm_prev_frame);
	tc.SelectGoodFeatures(&fl, g_sm_prev_frame);

	// Crop the mask and remove all feature points not in the mask area
	Set(&sm_obj_mask1, Point(0,0), object_mask1, context);
	Set(&sm_obj_mask2, Point(0,0), object_mask2, context);
	nfeatures = fl.GetNFeatures();
	for(i=0; i<nfeatures; i++) {
		if(fl[i]->x < 0 || fl[i]->x >= width || fl[i]->y < 0 || fl[i]->y >= height) {
			fl[i]->val = -1;
			fl[i]->x = 0;
			fl[i]->y = 0;
			continue;
		}
		if(!sm_obj_mask1(fl[i]->x, fl[i]->y) ) {
			fl[i]->val = -1;
		}
	}
	old_fl = fl;

	// Crop the current frame
	Set(&sm_curr_frame, Point(0,0), curr_frame, context);
	Convert(sm_curr_frame, &g_sm_curr_frame);
	
	// track the features
    tc.TrackFeatures(&fl, g_sm_prev_frame, g_sm_curr_frame);
    //tc.ReplaceLostFeatures(&fl, g_sm_curr_frame);

	// Display the motion vec..
	du = 0.0f; dv = 0.0f;
	nfeatures = fl.GetNFeatures();
	for(i=0; i<nfeatures; i++) {
		if(fl[i]->val < 0)
			continue;
		int prev_x = old_fl[i]->x + context.left;
		int prev_y = old_fl[i]->y + context.top;
		int curr_x = fl[i]->x + context.left;
		int curr_y = fl[i]->y + context.top;
		curr_x += (curr_x - prev_x)*2;
		curr_y += (curr_y - prev_y)*2;
		du += (fl[i]->x - old_fl[i]->x);
		dv += (fl[i]->y - old_fl[i]->y);
	}
	du /= num_features;
	dv /= num_features;

}
*/