#ifndef _RANSAC_H_
#define _RANSAC_H_

#include "configs.h"
#include <vector>

//int ransac(const double *x, const int rows, const int npts, const int s, const double t, double M[9], int *inliers);

int ransac(ProjectiveTransformation::WarpModel wm, DegeneracyCheck::Level dc, const double *x, const int rows, const int npts, const int s, const double t, 
           double M[9], std::vector<int>& inliers, 
		   bool (*DegenFnct)(ProjectiveTransformation::WarpModel, DegeneracyCheck::Level, const double *, const int),
		   int (*FittingFnct)(ProjectiveTransformation::WarpModel, double *, const int, const int, double []),
		   int (*DistFnct)(const double [], const double *, const int, const int, const double, int*),
           const int maxDegenTrials = RansacSetting::maxDegeneracyTrials,
           const int minRansacTrials = RansacSetting::minRansacTrials,
           const int maxRansacTrials = RansacSetting::maxRansacTrials);


#endif
