#pragma warning( disable: 4786 )  // identifier was truncated to '255' characters
#include "TrackerManager.h"

TrackerManager::TrackerManager(int width, int height)
	:m_width(width), m_height(height), m_num_objects(0)
{
	
}

int TrackerManager::AddObject(const ImgBgr &input_image, vector<Point>& points, double seg_sigma, ImgInt *const fg_label, ImgInt *const bg_label)
{
	try {
		ObjectTracker obj(input_image.Width(), input_image.Height());
		obj.Initialize(input_image, points, m_num_objects, seg_sigma, 3, fg_label, bg_label);
		m_objects.push_back(obj);
		m_num_objects++;
	}
	catch(...) {
		printf("Error while adding object.\n");
		return -1;
	}

	return m_num_objects-1;
}

void TrackerManager::TrackNextFrame(ImgBgr &current_frame, int frame_no)
{
	int i=0;

	for(i=0; i<m_objects.size(); i++) {
		m_objects[i].TrackNextFrame(current_frame, frame_no);
	}
}

void TrackerManager::DrawContour(ImgBgr& display_image)
{
	for(int i=0; i<m_objects.size(); i++) {
		m_objects[i].DrawContour(display_image);
	}
}

void TrackerManager::LoadStateFromFile(int object_id, const ImgInt& current_model)
{
	m_objects[object_id].LoadStateFromFile(current_model);
}