
#ifndef _BIPARTITEMATCHING_H
#define _BIPARTITEMATCHING_H

#include "../TheTracker.h"

#define INF 100000000.0f

class BipartiteMatching {
public:
	void DoBipartiteMatching(double **cost, int matrix_size, int *match_results, double& match_cost);
private:

	void _AllocateResource(int matrix_size);
	void _FreeResource();
	void _InitLabels(double **cost, int matrix_size);
	void _UpdateLabels(int matrix_size);
	void _AddToTree(int x, int prevx, double **cost, int matrix_size) ;
	void _Augment(double **cost, int matrix_size);

	int m_max_match;        //n workers and n jobs
	double *m_lx, *m_ly;        //labels of X and Y parts
	int *m_xy;               //xy[x] - vertex that is matched with x,
	int *m_yx;               //yx[y] - vertex that is matched with y
	bool *m_S, *m_T;         //sets S and T in algorithm
	double *m_slack;            //as in the algorithm description
	int *m_slackx;           //slackx[y] such a vertex, that
							 // l(slackx[y]) + l(y) - w(slackx[y],y) = slack[y]
	int *m_prev;             //array for memorizing alternating paths

};

#endif