
#ifndef _UTILS_H
#define _UTILS_H

#include "../TheTracker.h"

class Utils {

public:
	static void Inverse2x2(double input_mat[2][2], double out[2][2]);
	static bool Inverse3x3(double input_mat[3][3], double out[3][3]);
	static void RandomColor(const ImgInt& img, ImgBgr* out);
	static void RandomColor(const ImgGray& img, ImgBgr* out);
	static void _EdgeIndicator(const ImgFloat &Ix,const ImgFloat &Iy,ImgFloat *g);
	static void _ExtractContour(const ImgFloat &in,ImgInt *labels,int *area,vector<Point> *chain,boolean IsWallfollow);
	static void ConvertStrengthtoBinary(const ImgFloat& img, ImgBinary* out);
	static void HausdorffDistance(vector<Point> &p1, vector<Point> &p2,double *dist);
	static void SetLevelSetSpeed(const ImgFloat& img, ImgFloat* out);
	static double lap(int dim,double **assigncost,int *rowsol,int *colsol,double *u,double *v);

	// Mahalanobis Distance
	inline static void MahDistance2x2(double input_vec[], double mean_vec[], double inv_cov[2][2], double& out) {
		double x0 = input_vec[0] - mean_vec[0];
		double x1 = input_vec[1] - mean_vec[1];
		double tmp = x0 * x1;
		out = x0*x0*inv_cov[0][0] + tmp*(inv_cov[1][0]+inv_cov[0][1]) + x1*x1*inv_cov[1][1];
		out = exp(-out);
	};

	inline static void MahDistance3x3(double input_vec[], double mean_vec[], double inv_cov[3][3], double& out) {
		double x0 = input_vec[0] - mean_vec[0];
		double x1 = input_vec[1] - mean_vec[1];
		double x2 = input_vec[2] - mean_vec[2];
		out = x0*x0*inv_cov[0][0] + x1*x1*inv_cov[1][1] + x2*x2*inv_cov[2][2] + x0*x1*(inv_cov[1][0]+inv_cov[0][1]) + x0*x2*(inv_cov[2][0]+inv_cov[0][2]) + x1*x2*(inv_cov[2][1]+inv_cov[1][2]) ;
		out = exp(-out);
	};
};

#endif